<?php
/***
mg-eCards 1.0
Autor: Mario Girke
Version: 1.0
Datum: 09.07.2004
***/

require("config.inc");
require("template.inc");

$eCardData = array("image", "message",
                   "recName", "recEMail",
                   "sendName", "sendEMail",
                   "fontFamily", "fontSize", "fontColor", "bgColor");
$ControlVars = array("eCardSel", "eCardEdit",
                   "preview", "imgSel",
                   "send", "eCardPreview",
	   	   "cardID");
$checkTypes = array("message" => "noempty",
                    "recName" => "noempty",
                    "recEMail" => "noempty,email",
                    "sendName" => "noempty",
                    "sendEMail" => "noempty,email");


/**
*  parst die Editier-Seite, fgt bisherige Eingaben und evtl. Fehlerhinweise ein
*/

function buildEditPage($errMsg = NULL) {
    global $checkTypes, $eCardData;
    global $imgPath, $templatePath;

    $image = $_SESSION["image"];
    
    $tmpl = new Template($templatePath);
    $tmpl->set_file("page", "eCardEdit.html");

    $imgSize = getImageSize($imgPath."/".$image);
    $tmpl->set_var("imgSrc", $imgPath."/".$image);
    $tmpl->set_var("imgWidth", $imgSize[0]);
    $tmpl->set_var("imgHeight", $imgSize[1]);
    $tmpl->set_var("imgName", $image);
    //DebugBreak();
    foreach (array_keys($checkTypes) as $varName) {
        $tmpl->set_block("page",$varName."_Err");
        if ($errMsg[$varName])
            $tmpl->set_var($varName."_Err", "$varName must be ".$errMsg[$varName]);
    }

    foreach ($eCardData as $varName) {
        if ($varName != "image") {
            if (!isset($_SESSION[$varName])) $_SESSION[$varName] = "";
            $tmpl->set_var($varName, $_SESSION[$varName]);
        }
    }

    $tmpl->pparse("result", "page");
}

/**
*  erstellt (parst) Ansichts-/Preview-Seite
*/
function buildECardPage($isPreview = false) {
    global $imgPath, $templatePath;

    //DebugBreak();
    $image = $_SESSION["image"];

    $tmpl = new Template($templatePath);
    $tmpl->set_file("page", "eCardTemplate.html");

    $imgSize = getImageSize($imgPath."/".$image);
    $tmpl->set_var("imgSrc", $imgPath."/".$image);
    $tmpl->set_var("imgWidth", $imgSize[0]);
    $tmpl->set_var("imgHeight", $imgSize[1]);
    $tmpl->set_var("imgName", $image);

    $tmpl->set_block("page", "okBtn");
    $tmpl->set_block("page", "backBtn");
    ($isPreview) ? $tmpl->set_var("okBtn") : $tmpl->set_var("backBtn");
    ($isPreview) ? $tmpl->set_var("viewType", "eCardPreview") : $tmpl->set_var("viewType", "eCardView");
    ($isPreview) ? $tmpl->set_var("viewAction", "processECard.php") : $tmpl->set_var("viewAction", "javascript:window.close()");
    //$tmpl->set_var("viewAction", "javascript:window.close()");

    $eCardTextData = array("message", "recName", "sendName");
    foreach ($eCardTextData as $varName) {
        if (!isset($_SESSION[$varName])) $_SESSION[$varName] = "";
        $tmpl->set_var($varName, quote($_SESSION[$varName]));
    }
    $eCardFnctData = array("sendEMail", "fontFamily", "fontSize", "fontColor", "bgColor");
    foreach ($eCardFnctData as $varName) {
        if (!isset($_SESSION[$varName])) $_SESSION[$varName] = "";
        $tmpl->set_var($varName, $_SESSION[$varName]);
    }

    $tmpl->pparse("result", "page");
}

/**
*  erstellt (parst) Bildauswahl-Seite
*/
function buildImageSelPage() {
    global $imgPath, $templatePath;

    ($dh  = opendir($imgPath)) or die("Kann img-dir nicht ffnen");
    
    while (false !== ($filename = readdir($dh))) {
	if (is_file($imgPath."/".$filename))
	    $files[] = $filename;
    }
    #print_r($files);
    sort($files);
    $tmpl = new Template($templatePath);

    $tmpl->set_file("page", "eCardSel.html");
    $tmpl->set_block("page","Row", "Rows");
    $tmpl->set_block("page","LastRow", "LastRowBlock");
    
    //derzeit nur zweispaltiges Layout
    for($i=0; $i<((count($files) - 1)/2 ); $i++) {
	    $tmpl->set_var("image1", $files[$i * 2]);
	    $tmpl->set_var("image2", $files[$i * 2 + 1]);
	    $tmpl->set_var("imagepath1", $imgPath."/".$files[$i * 2]);
	    $tmpl->set_var("imagepath2", $imgPath."/".$files[$i * 2 + 1]);
	    $tmpl->parse("Rows", "Row", true);
    }
    if ($i==0) {
	    #nur ein Bild -> kein zweispaltiger Bereich
	    $tmpl->set_var("Rows", "");
    }
    if($i < count($files)/2) {
	#ein berzhliges Bild
	    $tmpl->set_var("image1", $files[$i * 2]);
	    $tmpl->set_var("imagepath1", $imgPath."/".$files[$i * 2]);
	    $tmpl->parse("LastRowBlock", "LastRow");
    } else {
	    $tmpl->set_var("LastRowBlock", "");
    }
	    

    $tmpl->pparse("result", "page");
}
/**
*  speichert eCard-Daten in Datenbank
*/
function saveECard() {
    global $host, $user, $passwd, $dbName, $eCardData;

    //DebugBreak();
    $dbh = mysql_connect($host, $user, $passwd)
           or $errMsg = "Could not connect to db server<br/>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}
    
    $fieldStr ="`CreationDate`, `CardID`";
    $valStr .= "Now(), '".$_SESSION["cardID"]."'";
    foreach ($eCardData as $varName) {
        $fieldStr .= ", `".$varName."`";
        $valStr .= ", '".$_SESSION[$varName]."'";
    }
    $sqlStr = "INSERT INTO `ecards` ($fieldStr) ".
              "VALUES ($valStr)";
              
    $rsh = mysql_db_query($dbName, $sqlStr, $dbh)
           or $errMsg = "Error storing eCard data to database<br/>sqlStr = $sqlStr</br>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}

    mysql_close($dbh);
}

/**
*  speichert die eCard-Daten aus Formular in Session-Variablen
*/
function saveFormVars() {
    global $HTTP_POST_VARS, $HTTP_GET_VARS, $eCardData;

    $tmpArray = empty( $HTTP_POST_VARS ) ? $HTTP_GET_VARS : $HTTP_POST_VARS;
    foreach ($eCardData as $varName) {
        if (isset($tmpArray[$varName])) $_SESSION[$varName] = $tmpArray[$varName];
    }
}

/**
*  schickt eMail-Mitteilung an Empfnger
*/
function sendNotifications() {
    global $HTTP_SERVER_VARS;
    global $imgPath, $templatePath;
    
    $viewPath = "http://".$HTTP_SERVER_VARS['HTTP_HOST']
                         .dirname($HTTP_SERVER_VARS['PHP_SELF'])
                         ."/viewCard.php?cardID=".$_SESSION["cardID"];
    $to = $_SESSION["recEMail"];
    $subject = $GLOBALS["NotificationSubject"];
    $tmpl = new Template($templatePath);
    $tmpl->set_file("mailMsg", "eCardMail.tpl");
    $tmpl->set_var("recName", $_SESSION["recName"]);
    $tmpl->set_var("link", $viewPath);

    $message = $tmpl->parse("result", "mailMsg");;
    $header = "From: ".$GLOBALS["eMailFrom"];
    if (!mail($to, $subject, $message, $header)) {
        return "Error: your card could not be send.</br>$php_errmsg";
    }
}

/**
*  schickt eMail-Mitteilung an Absender, dass eCard abgerufen wurde
*/
function sendViewedNotification() {
    global $imgPath, $templatePath;

    $to = $_SESSION["sendEMail"];
    $subject = $GLOBALS["ViewedNotificationSubject"];
    $tmpl = new Template($templatePath);
    $tmpl->set_file("mailMsg", "eCardViewedMail.tpl");
    $tmpl->set_var("sendName", $_SESSION["sendName"]);
    $tmpl->set_var("recName", $_SESSION["recName"]);

    $message = $tmpl->parse("result", "mailMsg");;
    $header = "From: ".$GLOBALS["eMailFrom"];
    mail($to, $subject, $message, $header);
}

/**
*  erstellt Fehlerseite, falls beim Speichern oder eMailen was schiefgelaufen ist
*/
function buildErrorPage($errMsg) {
    echo $errMsg;
}

function getCardData($cardID) {
    global $host, $user, $passwd, $dbName, $eCardData;

    //DebugBreak();
    $dbh = mysql_connect($host, $user, $passwd)
           or $errMsg = "Could not connect to db server<br/>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}
    $sqlStr = "SELECT * FROM `ecards` WHERE cardID = '$cardID'";
    $rsh = mysql_db_query($dbName, $sqlStr, $dbh)
           or $errMsg = "Error retrieving eCard data from database<br/>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}
    $res = mysql_fetch_assoc($rsh)
           or $errMsg = "No data found for cardID<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}

    foreach ($eCardData as $varName) {
        $_SESSION[$varName] = $res[$varName];
    }
    $_SESSION["viewed"] = $res["viewed"];

    mysql_close($dbh);

}

function hasAlreadyViewed() {
    return ($_SESSION["viewed"] == "Y");
}

function setAlreadyViewed() {
    global $host, $user, $passwd, $dbName;
    $cardID = $GLOBALS["cardID"];

    $dbh = mysql_connect($host, $user, $passwd)
           or $errMsg = "Could not connect to db server<br/>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}
    $sqlStr = "UPDATE `ecards` SET `viewed` = 'Y', `viewDate` = Now() WHERE cardID = '$cardID'";
    $rsh = mysql_db_query($dbName, $sqlStr, $dbh)
           or $errMsg = "Error setting `viewed` flag for eCard in database<br/>". mysql_errno($dbh).": ".mysql_error($dbh)."<br/>";
    if ($errMsg) {mysql_close($dbh); return $errMsg;}
    
    return $rsh;
}

/**
*  merkt sich die eCard-Daten fr die Session
*/
function registerVars() {
    global $eCardData;

    foreach ($eCardData as $varName) {
	    if (!isset($_SESSION[$varName])) 
		$_SESSION[$varName] = "";
    }
}

/**
*  ermittelt die per Post oder Get bergebenen Steuer-Daten
*/
function getFormVars() {
    global $ControlVars;
    
    foreach ($ControlVars as $varName) {
	if ( isset($_POST[$varName]) || isset($_GET[$varName]) ) {
	    $GLOBALS[$varName] = isset($_POST[$varName])?($_POST[$varName]):($_GET[$varName]);
    	}
    }
}

/**
*  beendet so sicher wie mglich die Session
*/
function endSession() {
    session_unset();
    session_destroy();
    $p = session_get_cookie_params();
    setcookie(session_name(), "", 0, $p["path"], $p["domain"]);
}

/**
*  ermittelt, eine eindeutige ID fr jede eCard
*/
function getUniqueCardID() {
    return md5(uniqid(rand(),1));
}


/**
*  ermittelt, ob eine Variable keinen Wert hat
*/
function isEmpty($varName) {
    $result = ( !isset($_SESSION[$varName]) || empty($_SESSION[$varName]) || $varName == "" );
    return $result;
}

/**
*  prft die Eingaben und gibt Fehlerhinweise zurck
*/
function checkInputs() {
    global $checkTypes;

    //DebugBreak();
    foreach ($checkTypes as $name => $val ) {
        $isError = false;
        $types = explode(",", $val);
        reset( $types );
        while ( list( , $type ) = each( $types ) ) {
            switch ( $type ) {
                case "noempty":if ( isEmpty($name) ) $isError = true; break;
                case "email": if ( !eregi( "^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3}$", $_SESSION[$name] ) ) $isError = true; break;
            }
            if ($isError) {
                $errMsg[$name] = $type;
                break;
            }
        }
    }
    return $errMsg;
}

//entschrft HTML-Specials in Texten und setzt <br> statt \n
function quote($text) {
	$text = htmlspecialchars($text, ENT_QUOTES);
	$text = nl2br($text);
	return $text;
}
?>
